//
//	aegis - project change supervisor
//	Copyright (C) 2005 Peter Miller;
//	All rights reserved.
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
//
// MANIFEST: implementation of the project_file_path_legacy class
//

#include <common/trace.h>
#include <libaegis/cstate.h>
#include <libaegis/project/file.h>


string_ty *
project_file_path(project_ty *pp, cstate_src_ty *src)
{
    trace(("project_file_path(pp = %8.8lX, src = %08lX)\n{\n", (long)pp,
	(long)src));
    string_ty *result =
	(
	    src->uuid
	?
	    project_file_path_by_uuid(pp, src->uuid)
	:
	    project_file_path(pp, src->file_name)
	);
    trace(("return \"%s\";\n", (result ? result->str_text : "")));
    trace(("}\n"));
    return result;
}
